Project Chrono: chrono::ChLinkMarkers Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
chrono::ChLinkMarkers Class Reference

## Description

Class for links which connect two 'markers'.

The markers are two ChMarker objects each belonging to the two linked ChBody parts. Many specialized classes are based on this ChLinkMarkers class, for example the family of ChLinkLock classes. ChLinkMarkers class allows an optional force vector and torque vector to be set between the two connected markers.

`#include <ChLinkMarkers.h>`

Inheritance diagram for chrono::ChLinkMarkers:
[legend]
Collaboration diagram for chrono::ChLinkMarkers:
[legend]

## Public Member Functions
virtual ChLinkMarkers * | Clone () const override
| "Virtual" copy constructor (covariant return type).
ChMarker * | GetMarker1 () const
| Return the 1st referenced marker (the secondary marker, on 1st body).
ChMarker * | GetMarker2 () const
| Return the 2nd referenced marker (the main marker, on 2nd body).
virtual ChFrame | GetFrame1Rel () const override
| Get the link frame 1, relative to body 1.
virtual ChFrame | GetFrame2Rel () const override
| Get the link frame 2, relative to body 2.
const ChCoordsysd & | GetRelCoordsys () const
| Relative position of marker 1 respect to marker 2.
const ChCoordsysd & | GetRelCoordsysDt () const
| Relative speed of marker 1 respect to marker 2.
const ChCoordsysd & | GetRelCoordsysDt2 () const
| Relative acceleration of marker 1 respect to marker 2.
double | GetRelAngle () const
| Relative rotation angle of marker 1 respect to marker 2.
const ChVector3d & | GetRelAxis () const
| Relative finite rotation axis of marker 1 respect to marker 2.
const ChVector3d & | GetRelAngleAxis () const
const ChVector3d & | GetRelativeAngVel () const
| Relative angular speed of marker 1 respect to marker 2.
const ChVector3d & | GetRelativeAngAcc () const
| Relative angular acceleration of marker 1 respect to marker 2.
double | GetDistance () const
| Relative 'polar' distance of marker 1 respect to marker 2.
double | GetDistanceDt () const
| Relative speed of marker 1 respect to marker 2, along the polar distance vector.
const ChVector3d & | GetAccumulatedForce () const
| Get the total applied force accumulators (force, momentum) in link coords.
const ChVector3d & | GetAccumulatedTorque () const
virtual void | SetupMarkers (ChMarker *mark1, ChMarker *mark2)
| Set the two markers associated with this link.
virtual void | Initialize (std::shared_ptr< ChMarker > mark1, std::shared_ptr< ChMarker > mark2)
| Initialize the link to join two markers.
virtual void | Initialize (std::shared_ptr< ChBody > mbody1, std::shared_ptr< ChBody > mbody2, const ChFrame<> &frame)
| Initialize the link to join two rigid bodies.
virtual void | Initialize (std::shared_ptr< ChBody > mbody1, std::shared_ptr< ChBody > mbody2, bool rel_frames, const ChFrame<> &frame1, const ChFrame<> &frame2)
| Initialize the link to join two rigid bodies.
virtual ChFrame | GetVisualModelFrame (unsigned int nclone=0) const override
| Get the reference frame (expressed in and relative to the absolute frame) of the visual model.
virtual void | UpdateRelMarkerCoords ()
| Updates auxiliary quantities for all relative degrees of freedom of the two markers.
virtual void | UpdateForces (double mytime)
| Updates auxiliary forces caused by springs/dampers/etc.
virtual void | Update (double mytime, bool update_assets=true) override
| Complete link update: UpdateTime -> UpdateRelMarkerCoords -> UpdateForces.
virtual void | IntLoadResidual_F (const unsigned int off, ChVectorDynamic<> &R, const double c) override
| Adds force to residual R, as R*= F*c NOTE: here the off offset in R is NOT used because add F at the TWO offsets of the two connected bodies, so it is assumed that offsets for Body1 and Body2 variables have been already set properly!
virtual void | ConstraintsFbLoadForces (double factor=1) override
| Overrides the empty behaviour of the parent ChLink implementation, which does not consider any user-imposed force between the two bodies.
virtual void | ArchiveOut (ChArchiveOut &archive_out) override
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in) override
| Method to allow deserialization of transient data from archives.
Public Member Functions inherited from chrono::ChLink
| ChLink (const ChLink &other)
virtual unsigned int | GetNumAffectedCoords () override
| Get the number of scalar variables affected by constraints in this link.
ChBodyFrame * | GetBody1 () const
| Get the constrained body 1.
ChBodyFrame * | GetBody2 () const
| Get the constrained body 2.
virtual ChFramed | GetFrame1Abs () const override
| Get the link frame 1, on body 1, expressed in the absolute frame.
virtual ChFramed | GetFrame2Abs () const override
| Get the link frame 2, on body 2, expressed in the absolute frame.
virtual ChWrenchd | GetReaction1 () const override
| Get the reaction force and torque on the 1st body, expressed in the link frame 1.
virtual ChWrenchd | GetReaction2 () const override
| Get the reaction force and torque on the 2nd body object, expressed in the link frame 2.
virtual void | UpdateTime (double mytime)
| Given new time, current body state, update time-dependent quantities in link state, for example motion laws, moving markers, etc.
virtual void | Update (bool update_assets=true) override
| As above, but with current time.
virtual void | UpdatedExternalTime (double prevtime, double time)
| Called from a external package (i.e. a plugin, a CAD app.) to report that time has changed.
Public Member Functions inherited from chrono::ChLinkBase
| ChLinkBase (const ChLinkBase &other)
bool | IsValid ()
| Tells if the link data is currently valid.
void | SetValid (bool mon)
| Set the status of link validity.
bool | IsDisabled ()
| Tells if all constraints of this link are currently turned on or off by the user.
virtual void | SetDisabled (bool mdis)
| User can use this to enable/disable all the constraint of the link as desired.
bool | IsBroken ()
| Tells if the link is broken, for excess of pulling/pushing.
virtual void | SetBroken (bool mon)
| Set the 'broken' status vof this link.
virtual bool | IsActive () const override
| Return true if the link is currently active and thereofre included into the system solver.
virtual ChVectorDynamic | GetConstraintViolation () const
| Get the current constraint violations.
virtual bool | IsRequiringWaking ()
| Tells if this link requires that the connected ChBody objects must be waken if they are sleeping.
Public Member Functions inherited from chrono::ChPhysicsItem
| ChPhysicsItem (const ChPhysicsItem &other)
ChSystem * | GetSystem () const
| Get the pointer to the parent ChSystem().
virtual void | SetSystem (ChSystem *m_system)
| Set the pointer to the parent ChSystem().
void | AddVisualModel (std::shared_ptr< ChVisualModel > model)
| Add an (optional) visualization model.
std::shared_ptr< ChVisualModel > | GetVisualModel () const
| Access the visualization model (if any).
void | AddVisualShape (std::shared_ptr< ChVisualShape > shape, const ChFrame<> &frame=ChFrame<>())
| Add the specified visual shape to the visualization model.
std::shared_ptr< ChVisualShape > | GetVisualShape (unsigned int i) const
| Access the specified visualization shape in the visualization model (if any).
void | AddVisualShapeFEA (std::shared_ptr< ChVisualShapeFEA > shapeFEA)
| Add the specified FEA visualization object to the visualization model.
std::shared_ptr< ChVisualShapeFEA > | GetVisualShapeFEA (unsigned int i) const
| Access the specified FEA visualization object in the visualization model (if any).
virtual unsigned int | GetNumVisualModelClones () const
| Return the number of clones of the visual model associated with this physics item.
void | AddCamera (std::shared_ptr< ChCamera > camera)
| Attach a ChCamera to this physical item.
std::vector< std::shared_ptr< ChCamera > > | GetCameras () const
| Get the set of cameras attached to this physics item.
virtual bool | IsCollisionEnabled () const
| Tell if the object is subject to collision.
virtual void | AddCollisionModelsToSystem (ChCollisionSystem *coll_sys) const
| Add to the provided collision system any collision models managed by this physics item.
virtual void | RemoveCollisionModelsFromSystem (ChCollisionSystem *coll_sys) const
| Remove from the provided collision system any collision models managed by this physics item.
virtual void | SyncCollisionModels ()
| Synchronize the position and bounding box of any collsion models managed by this physics item.
virtual ChAABB | GetTotalAABB ()
| Get the entire AABB axis-aligned bounding box of the object.
virtual void | GetCenter (ChVector3d &mcenter)
| Get a symbolic 'center' of the object.
virtual void | Setup ()
| This might recompute the number of coordinates, DOFs, constraints, in case this might change (ex in ChAssembly), as well as state offsets of contained items (ex in ChMesh).
virtual void | ForceToRest ()
| Set zero speed (and zero accelerations) in state, without changing the position.
virtual unsigned int | GetNumCoordsPosLevel ()
| Get the number of coordinates at the position level.
virtual unsigned int | GetNumCoordsVelLevel ()
| Get the number of coordinates at the velocity level.
virtual unsigned int | GetNumConstraints ()
| Get the number of scalar constraints.
virtual unsigned int | GetNumConstraintsBilateral ()
| Get the number of bilateral scalar constraints.
virtual unsigned int | GetNumConstraintsUnilateral ()
| Get the number of unilateral scalar constraints.
unsigned int | GetOffset_x ()
| Get offset in the state vector (position part).
unsigned int | GetOffset_w ()
| Get offset in the state vector (speed part).
unsigned int | GetOffset_L ()
| Get offset in the lagrangian multipliers.
void | SetOffset_x (const unsigned int moff)
| Set offset in the state vector (position part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_w (const unsigned int moff)
| Set offset in the state vector (speed part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_L (const unsigned int moff)
| Set offset in the lagrangian multipliers Note: only the ChSystem::Setup function should use this.
virtual void | IntStateGather (const unsigned int off_x, ChState &x, const unsigned int off_v, ChStateDelta &v, double &T)
| From item's state to global state vectors y={x,v} pasting the states at the specified offsets.
virtual void | IntStateScatter (const unsigned int off_x, const ChState &x, const unsigned int off_v, const ChStateDelta &v, const double T, bool full_update)
| From global state vectors y={x,v} to item's state (and update) fetching the states at the specified offsets.
virtual void | IntStateGatherAcceleration (const unsigned int off_a, ChStateDelta &a)
| From item's state acceleration to global acceleration vector.
virtual void | IntStateScatterAcceleration (const unsigned int off_a, const ChStateDelta &a)
| From global acceleration vector to item's state acceleration.
virtual void | IntStateGatherReactions (const unsigned int off_L, ChVectorDynamic<> &L)
| From item's reaction forces to global reaction vector.
virtual void | IntStateScatterReactions (const unsigned int off_L, const ChVectorDynamic<> &L)
| From global reaction vector to item's reaction forces.
virtual void | IntStateIncrement (const unsigned int off_x, ChState &x_new, const ChState &x, const unsigned int off_v, const ChStateDelta &Dv)
| Computes x_new = x + Dt , using vectors at specified offsets.
virtual void | IntStateGetIncrement (const unsigned int off_x, const ChState &x_new, const ChState &x, const unsigned int off_v, ChStateDelta &Dv)
| Computes Dt = x_new - x, using vectors at specified offsets.
virtual void | IntLoadResidual_Mv (const unsigned int off, ChVectorDynamic<> &R, const ChVectorDynamic<> &w, const double c)
| Takes the M*v term, multiplying mass by a vector, scale and adds to R at given offset: R += c*M*w.
virtual void | IntLoadLumpedMass_Md (const unsigned int off, ChVectorDynamic<> &Md, double &err, const double c)
| Adds the lumped mass to a Md vector, representing a mass diagonal matrix.
virtual void | IntLoadResidual_CqL (const unsigned int off_L, ChVectorDynamic<> &R, const ChVectorDynamic<> &L, const double c)
| Takes the term Cq'*L, scale and adds to R at given offset: R += c*Cq'*L.
virtual void | IntLoadConstraint_C (const unsigned int off, ChVectorDynamic<> &Qc, const double c, bool do_clamp, double recovery_clamp)
| Takes the term C, scale and adds to Qc at given offset: Qc += c*C.
virtual void | IntLoadConstraint_Ct (const unsigned int off, ChVectorDynamic<> &Qc, const double c)
| Takes the term Ct, scale and adds to Qc at given offset: Qc += c*Ct.
virtual void | IntToDescriptor (const unsigned int off_v, const ChStateDelta &v, const ChVectorDynamic<> &R, const unsigned int off_L, const ChVectorDynamic<> &L, const ChVectorDynamic<> &Qc)
| Prepare variables and constraints to accommodate a solution:
virtual void | IntFromDescriptor (const unsigned int off_v, ChStateDelta &v, const unsigned int off_L, ChVectorDynamic<> &L)
| After a solver solution, fetch values from variables and constraints into vectors:
virtual void | InjectVariables (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChVariable objects associated with this item.
virtual void | InjectConstraints (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChConstraint objects associated with this item.
virtual void | LoadConstraintJacobians ()
| Compute and load current Jacobians in encapsulated ChConstraint objects.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor)
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
virtual void | VariablesFbReset ()
| Sets the 'fb' part (the known term) of the encapsulated ChVariables to zero.
virtual void | VariablesFbLoadForces (double factor=1)
| Adds the current forces (applied to item) into the encapsulated ChVariables, in the 'fb' part: qf+=forces*factor.
virtual void | VariablesQbLoadSpeed ()
| Initialize the 'qb' part of the ChVariables with the current value of speeds.
virtual void | VariablesFbIncrementMq ()
| Adds M*q (masses multiplied current 'qb') to Fb, ex.
virtual void | VariablesQbSetSpeed (double step=0)
| Fetches the item speed (ex.
virtual void | VariablesQbIncrementPosition (double step)
| Increment item positions by the 'qb' part of the ChVariables, multiplied by a 'step' factor.
virtual void | ConstraintsBiReset ()
| Sets to zero the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_C (double factor=1, double recovery_clamp=0.1, bool do_clamp=false)
| Adds the current C (constraint violation) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Ct (double factor=1)
| Adds the current Ct (partial t-derivative, as in C_dt=0-> [Cq]*q_dt=-Ct) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Qc (double factor=1)
| Adds the current Qc (the vector of C_dtdt=0 -> [Cq]*q_dtdt=Qc ) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsFetch_react (double factor=1)
| Fetches the reactions from the lagrangian multiplier (l_i) of encapsulated ChConstraints.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual std::string & | ArchiveContainerName ()

## Protected Member Functions
| ChLinkMarkers (const ChLinkMarkers &other)
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()

## Protected Attributes
ChMarker * | marker1
| secondary coordsys
ChMarker * | marker2
| main coordsys
ChCoordsysd | relM
| relative marker position 2-1
ChCoordsysd | relM_dt
| relative marker speed
ChCoordsysd | relM_dtdt
| relative marker acceleration
double | relAngle
| relative angle of rotation
ChVector3d | relAxis
| relative axis of rotation
ChVector3d | relRotaxis
| relative rotaion vector =angle*axis
ChVector3d | relWvel
| relative angular speed
ChVector3d | relWacc
| relative angular acceleration
double | dist
| the distance between the two origins of markers,
double | dist_dt
| the speed between the two origins of markers
ChVector3d | C_force
| internal force applied by springs/dampers/actuators
ChVector3d | C_torque
| internal torque applied by springs/dampers/actuators
ChVector3d | PQw
ChVector3d | PQw_dt
ChVector3d | PQw_dtdt
ChQuaternion | q_AD
ChQuaternion | q_BC
ChQuaternion | q_8
ChVector3d | q_4
Protected Attributes inherited from chrono::ChLink
ChBodyFrame * | m_body1
| first connected body
ChBodyFrame * | m_body2
| second connected body
ChVector3d | react_force
| xyz reactions, expressed in local coordinate system of link;
ChVector3d | react_torque
| torque reactions, expressed in local coordinate system of link;
Protected Attributes inherited from chrono::ChLinkBase
bool | disabled
| all constraints of link disabled because of user needs
bool | valid
| link data is valid
bool | broken
| link is broken because of excessive pulling/pushing.
Protected Attributes inherited from chrono::ChPhysicsItem
ChSystem * | system
| parent system
std::shared_ptr< ChVisualModelInstance > | vis_model_instance
| instantiated visualization model
std::vector< std::shared_ptr< ChCamera > > | cameras
| set of cameras
unsigned int | offset_x
| offset in vector of state (position part)
unsigned int | offset_w
| offset in vector of state (speed part)
unsigned int | offset_L
| offset in vector of lagrangian multipliers
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Member Function Documentation

## ◆ ArchiveIn()

void chrono::ChLinkMarkers::ArchiveIn | ( | ChArchiveIn & | archive_in | ) |
| overridevirtual

Method to allow deserialization of transient data from archives.

Method to allow de serialization of transient data from archives.

Reimplemented from chrono::ChLink.

Reimplemented in chrono::ChLinkBushing, chrono::ChLinkLock, chrono::ChLinkLockBrake, chrono::ChLinkLockClearance, chrono::ChLinkLockGear, chrono::ChLinkLockLinActuator, chrono::ChLinkLockLock, chrono::ChLinkLockPointSpline, chrono::ChLinkLockPulley, chrono::ChLinkLockScrew, and chrono::ChLinkLockTrajectory.

## ◆ ArchiveOut()

void chrono::ChLinkMarkers::ArchiveOut | ( | ChArchiveOut & | archive_out | ) |
| overridevirtual

Method to allow serialization of transient data to archives.

Reimplemented from chrono::ChLink.

Reimplemented in chrono::ChLinkBushing, chrono::ChLinkLock, chrono::ChLinkLockBrake, chrono::ChLinkLockClearance, chrono::ChLinkLockGear, chrono::ChLinkLockLinActuator, chrono::ChLinkLockLock, chrono::ChLinkLockPointSpline, chrono::ChLinkLockPulley, chrono::ChLinkLockScrew, and chrono::ChLinkLockTrajectory.

## ◆ Clone()

virtual ChLinkMarkers * chrono::ChLinkMarkers::Clone | ( |  | ) | const
| inlineoverridevirtual

"Virtual" copy constructor (covariant return type).

Reimplemented from chrono::ChPhysicsItem.

Reimplemented in chrono::ChLinkBushing, chrono::ChLinkLock, chrono::ChLinkLockAlign, chrono::ChLinkLockBrake, chrono::ChLinkLockClearance, chrono::ChLinkLockCylindrical, chrono::ChLinkLockFree, chrono::ChLinkLockGear, chrono::ChLinkLockLinActuator, chrono::ChLinkLockLock, chrono::ChLinkLockOldham, chrono::ChLinkLockParallel, chrono::ChLinkLockPerpend, chrono::ChLinkLockPlanar, chrono::ChLinkLockPointLine, chrono::ChLinkLockPointPlane, chrono::ChLinkLockPointSpline, chrono::ChLinkLockPrismatic, chrono::ChLinkLockPulley, chrono::ChLinkLockRevolute, chrono::ChLinkLockRevolutePrismatic, chrono::ChLinkLockScrew, chrono::ChLinkLockSpherical, and chrono::ChLinkLockTrajectory.

## ◆ ConstraintsFbLoadForces()

void chrono::ChLinkMarkers::ConstraintsFbLoadForces | ( | double | factor = 1 | ) |
| overridevirtual

Overrides the empty behaviour of the parent ChLink implementation, which does not consider any user-imposed force between the two bodies.

It adds the current link-forces, if any, (caused by springs, etc.) to the 'fb' vectors of the ChVariables referenced by encapsulated ChConstraints. In details, it adds the effect caused by C_force and C_torque. Both C_force and C_torque these forces are considered expressed in the reference coordsystem of marker2 (the MAIN marker), and their application point is the origin of marker1 (the SLAVE marker).

Reimplemented from chrono::ChPhysicsItem.

## ◆ GetAccumulatedForce()

const ChVector3d & chrono::ChLinkMarkers::GetAccumulatedForce | ( |  | ) | const
| inline

Get the total applied force accumulators (force, momentum) in link coords.

These forces might be affected by additional springs, dampers, etc. but they do not include the reaction forces.

## ◆ GetFrame1Rel()

virtual ChFrame chrono::ChLinkMarkers::GetFrame1Rel | ( |  | ) | const
| inlineoverridevirtual

Get the link frame 1, relative to body 1.

For this class link frame 1 is actually marker 1.

Implements chrono::ChLink.

## ◆ GetFrame2Rel()

virtual ChFrame chrono::ChLinkMarkers::GetFrame2Rel | ( |  | ) | const
| inlineoverridevirtual

Get the link frame 2, relative to body 2.

For this class link frame 2 is actually marker 2.

Implements chrono::ChLink.

## ◆ GetVisualModelFrame()

virtual ChFrame chrono::ChLinkMarkers::GetVisualModelFrame | ( | unsigned int | nclone = 0 | ) | const
| inlineoverridevirtual

Get the reference frame (expressed in and relative to the absolute frame) of the visual model.

For a ChLinkMarkers, this returns the absolute coordinate system of the main marker2.

Reimplemented from chrono::ChLinkBase.

## ◆ Initialize() [1/3]

void chrono::ChLinkMarkers::Initialize | ( | std::shared_ptr< ChBody > | mbody1,
|  | std::shared_ptr< ChBody > | mbody2,
|  | bool | rel_frames,
|  | const ChFrame<> & | frame1,
|  | const ChFrame<> & | frame2 )
| virtual

Initialize the link to join two rigid bodies.

This version uses the local positions and alignments on the two bodies. Both rigid bodies must belong to the same system. Two markers will be created and added to the rigid bodies.

Parameters

  mbody1 | first body to join
  mbody2 | second body to join
  rel_frames | marker frames are relative (true) or absolute (false)
  frame1 | position & alignment of 1st marker (absolute or relative to body1)
  frame2 | position & alignment of 2nd marker (absolute or relative to body2)

## ◆ Initialize() [2/3]

void chrono::ChLinkMarkers::Initialize | ( | std::shared_ptr< ChBody > | mbody1,
|  | std::shared_ptr< ChBody > | mbody2,
|  | const ChFrame<> & | frame )
| virtual

Initialize the link to join two rigid bodies.

Both rigid bodies must belong to the same system. This version creates the link at the specified absolute position and alignment. Two markers will be created and added to the rigid bodies.

Parameters

  mbody1 | first body to join
  mbody2 | second body to join
  frame | initial absolute position & alignment

## ◆ Initialize() [3/3]

void chrono::ChLinkMarkers::Initialize | ( | std::shared_ptr< ChMarker > | mark1,
|  | std::shared_ptr< ChMarker > | mark2 )
| virtual

Initialize the link to join two markers.

Each marker must belong to a rigid body, and both rigid bodies must belong to the same system. The position of mark2 is used as link's position and main reference.

Parameters

  mark1 | first marker to join (secondary)
  mark2 | second marker to join (main)

## ◆ IntLoadResidual_F()

void chrono::ChLinkMarkers::IntLoadResidual_F | ( | const unsigned int | off,
|  | ChVectorDynamic<> & | R,
|  | const double | c )
| overridevirtual

Adds force to residual R, as R*= F*c NOTE: here the off offset in R is NOT used because add F at the TWO offsets of the two connected bodies, so it is assumed that offsets for Body1 and Body2 variables have been already set properly!

Reimplemented from chrono::ChPhysicsItem.

## ◆ SetupMarkers()

void chrono::ChLinkMarkers::SetupMarkers | ( | ChMarker * | mark1,
|  | ChMarker * | mark2 )
| virtual

Set the two markers associated with this link.

Reimplemented in chrono::ChLinkLock.

## ◆ Update()

void chrono::ChLinkMarkers::Update | ( | double | mytime,
|  | bool | update_assets = true )
| overridevirtual

Complete link update: UpdateTime -> UpdateRelMarkerCoords -> UpdateForces.

Reimplemented from chrono::ChLink.

Reimplemented in chrono::ChLinkLock.

## ◆ UpdateForces()

void chrono::ChLinkMarkers::UpdateForces | ( | double | mytime | ) |
| virtual

Updates auxiliary forces caused by springs/dampers/etc.

which may be connected between the two link bodies. These forces are considered in the reference coordsystem of marker2 (the main marker), and their application point is the origin of marker1 (the secondary marker).

Reimplemented in chrono::ChLinkLock, chrono::ChLinkLockBrake, and chrono::ChLinkLockClearance.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChLinkMarkers.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChLinkMarkers.cpp